package sun.java2d.loops;

import sun.java2d.SurfaceData;
import sun.java2d.SunGraphics2D;

public class FillParallelogram extends GraphicsPrimitive
{
    public static final String methodSignature;
    public static final int primTypeID;
    
    public static FillParallelogram locate(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        return (FillParallelogram)GraphicsPrimitiveMgr.locate(FillParallelogram.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    protected FillParallelogram(SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        super(FillParallelogram.methodSignature, FillParallelogram.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    public FillParallelogram(long n, SurfaceType surfaceType, CompositeType compositeType, SurfaceType surfaceType2) {
        super(n, FillParallelogram.methodSignature, FillParallelogram.primTypeID, surfaceType, compositeType, surfaceType2);
    }
    
    public native void FillParallelogram(SunGraphics2D p0, SurfaceData p1, double p2, double p3, double p4, double p5, double p6, double p7);
    
    @Override
    public GraphicsPrimitive makePrimitive(SurfaceType obj, CompositeType obj2, SurfaceType surfaceType) {
        throw new InternalError("FillParallelogram not implemented for " + obj + " with " + obj2);
    }
    
    @Override
    public GraphicsPrimitive traceWrap() {
        return new FillParallelogram.TraceFillParallelogram(this);
    }
    
    static {
        methodSignature = "FillParallelogram(...)".toString();
        primTypeID = GraphicsPrimitive.makePrimTypeID();
    }
    
    private static class TraceFillParallelogram extends FillParallelogram
    {
        FillParallelogram target;
        
        public TraceFillParallelogram(FillParallelogram target) {
            super(target.getSourceType(), target.getCompositeType(), target.getDestType());
            this.target = target;
        }
        
        @Override
        public GraphicsPrimitive traceWrap() {
            return this;
        }
        
        @Override
        public void FillParallelogram(SunGraphics2D sunGraphics2D, SurfaceData surfaceData, double n, double n2, double n3, double n4, double n5, double n6) {
            GraphicsPrimitive.tracePrimitive(this.target);
            this.target.FillParallelogram(sunGraphics2D, surfaceData, n, n2, n3, n4, n5, n6);
        }
    }
}
